package uoc.tfc;

import java.io.IOException;
import java.util.Iterator;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


/**
 * Servlet implementation class ControlServlet
 */
public class ControlServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	private DBModel DBM;
	private String detalle = null;
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ControlServlet() {
        super();
        
    }
    
    public void init(ServletConfig config) throws ServletException {
        super.init(config);
        // Crear la conexion con la base de datos
        DBM = new DBModel();
     }
 
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		String siguienteURL = "/inicio.jsp";
		String boton = request.getParameter("boton");
		String boton1 = request.getParameter("boton1");
		String radio = request.getParameter("radio");
		
		if (boton1 != null && boton1.equals("Inicio")) {	
			siguienteURL = "/inicio.jsp";
			detalle = null;
		
		}else if (boton.equals("Descarga")) {
			siguienteURL = "/descarga.jsp";
			
			DBM.cargaModelos();
			Iterator<String>  exIt = DBM.listaObrasCargadas(); 
			request.setAttribute("respuesta", exIt);
			request.setAttribute("error", "");
			
		} else 	if (boton.equals("Consulta")) {
			
			if (detalle != null) {
				radio = detalle;
			}
			
			if (radio == null) {
				siguienteURL = "/inicio.jsp";
				request.setAttribute("error", " Debes indicar el tipo de consulta !! ");
				
			} else {
				
				if (DBM.verificarModelos()) {
				
					if (radio.equals("Peliculas")) {
						siguienteURL = "/consulta.jsp";
						detalle = radio; 
						Iterator<String>  exIt = DBM.listaPeliculasCargadas(); 
						request.setAttribute("respuesta", exIt);
						request.setAttribute("error", "");
						request.setAttribute("titulo","Peliculas");
					
					} else if (radio.equals("Directores")) {
						siguienteURL = "/consulta.jsp";
						detalle = radio;
						Iterator<String>  exIt = DBM.listaDirectoresCargados(); 
						request.setAttribute("respuesta", exIt);
						request.setAttribute("error", "");
						request.setAttribute("titulo","Directores");
					
					} else if (radio.equals("Productores")) {
						siguienteURL = "/consulta.jsp";
						detalle = radio;
						Iterator<String>  exIt = DBM.listaProductoresCargados(); 
						request.setAttribute("respuesta", exIt);
						request.setAttribute("error", "");
						request.setAttribute("titulo","Productores");
					
					} else if (radio.equals("Protagonistas")) {
						siguienteURL = "/consulta.jsp";
						detalle = radio;
						Iterator<String>  exIt = DBM.listaProtagonistasCargados(); 
						request.setAttribute("respuesta", exIt);
						request.setAttribute("error", "");
						request.setAttribute("titulo","Protagonistas");
					}
				} else {
					siguienteURL = "/inicio.jsp";
					request.setAttribute("error", "Debe realizar una descarga antes !!");
				}
				
			}
			
		} else if (boton.equals("Inicio")) {
			
			siguienteURL = "/inicio.jsp";
			detalle = null;
			
		} else {
			
			siguienteURL = "/detalle.jsp";
			
			if (detalle.equals("Peliculas")) {
				Pelicula pelicula = DBM.consultaFichaPelicula(boton);
				request.setAttribute("pelicula", pelicula);
				request.setAttribute("representar", "Peliculas");
				request.setAttribute("error", "");
				
			} else if (detalle.equals("Directores")) {
				Director director = DBM.consultaFichaDirector(boton);
				request.setAttribute("director", director);
				request.setAttribute("representar", "Directores");
				request.setAttribute("error", "");
				
			} else if (detalle.equals("Productores")) {
				Productor productor = DBM.consultaFichaProductor(boton);
				request.setAttribute("productor", productor);
				request.setAttribute("representar", "Productores");
				request.setAttribute("error", "");
				
			} else if (detalle.equals("Protagonistas")) {
				Protagonista protagonista = DBM.consultaFichaProtagonista(boton);
				request.setAttribute("protagonista", protagonista);
				request.setAttribute("representar", "Protagonistas");
				request.setAttribute("error", "");
			}
			
		}
		
		
		ServletContext context = getServletContext();
		RequestDispatcher dispatcher = context.getRequestDispatcher(siguienteURL);
		dispatcher.forward(request, response);
		
	}
	
	public void destroy() {
        
		DBM.cerrarConexion();
		DBM = null;
    }

}
